Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2019686 - Review Request: python-pynrrd - Pynrrd is used for reading and writing NRRD files into and from numpy arrays
Summary: Review Request: python-pynrrd - Pynrrd is used for reading and writing NRRD f...
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: 35
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Ankur Sinha (FranciscoD)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR FE-DEADREVIEW fedora-neuro, NeuroFedora
TreeView+ depends on / blocked
 
Reported: 2021-11-03 06:23 UTC by Hafsat
Modified: 2022-02-18 00:45 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-02-18 00:45:13 UTC
Type: Bug
Embargoed:


Attachments (Terms of Use)
. (deleted)
2021-11-03 06:23 UTC, Hafsat
no flags Details

Description Hafsat 2021-11-03 06:23:24 UTC
Created attachment 1839497 [details]
.

Created attachment 1839497 [details]
.

Created attachment 1839497 [details]
.

Created attachment 1839497 [details]
SPEC URL - https://pagure.io/python-pynrrd/raw/main/f/python-pynrrd.spec
SRPM URL - https://pagure.io/Python-pynrrd/raw/main/f/python-pynrrd-0.4.2-1.fc36.src.rpm

Description:

Pynrrd is a pure-Python module for reading and writing NRRD files into and from
numpy arrays.  NRRD stands for Nearly Raw Raster Data and is a file format
designed for scientific visualization and image processing involving
N-dimensional data.  It is a simple and flexible file format with a header
containing information about the data that can be read by simply opening the
NRRD file in a text editor.
 
Many other file formats such as PNG, JPG, DICOM cannot be read with a simple
text editor!  In addition, the raw data can be stored in a NRRD file in a
number of commonly known formats such as ASCII, gzip, bzip or even raw.  The
header information and data itself can be stored in the same file or
separately.  Another feature of the NRRD file format is the support of custom
key/value pairsin the header to allow storing of user information not defined
in the NRRD specification.

Fedora Account System Username: hafsat

I am a new packager and I am looking for a Sponsor.

Comment 1 Hafsat 2021-11-03 06:26:47 UTC
@

Comment 4 Adeleye Opeyemi 2021-11-15 14:22:25 UTC
This is an unofficial review. I am looking for a sponsor.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Dist tag is present.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 45 files have unknown license. Detailed output of
     licensecheck in /home/ope/2019686-python-pynrrd/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
python-pynrrd.src: W: strange-permission python-pynrrd.spec 600
 2 packages and 1 specfiles checked; 0 errors, 1 warnings, 0 badness; has taken 2.9 s 



Source checksums
----------------
https://github.com/mhe/pynrrd/archive/refs/tags/v0.4.2.tar.gz :
  CHECKSUM(SHA256) this package     : 0e0c60c9927adb31d97a7e3d00756dec987f115b2857dec0d6e4641490acfbd6
  CHECKSUM(SHA256) upstream package : 0e0c60c9927adb31d97a7e3d00756dec987f115b2857dec0d6e4641490acfbd6


Requires
--------
python3-pynrrd (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(numpy)



Provides
--------
python3-pynrrd:
    python-pynrrd
    python3-pynrrd
    python3.10-pynrrd
    python3.10dist(pynrrd)
    python3dist(pynrrd)



Diff spec file in url and in SRPM
---------------------------------
--- /home/ope/2019686-python-pynrrd/srpm/python-pynrrd.spec	2021-11-15 02:59:51.869796326 -0500
+++ /home/ope/2019686-python-pynrrd/srpm-unpacked/python-pynrrd.spec	2021-11-14 10:56:16.000000000 -0500
@@ -1,2 +1,11 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.2.5)
+%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
+    release_number = 1;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
+## END: Set by rpmautospec
+
 Name:           python-pynrrd
 Version:        0.4.2
@@ -67,4 +76,4 @@
 
 %changelog
-%autochangelog
-
+* Sun Nov 14 2021 Hafsat Ajia-EGbeyemi <hafsatajia> 0.4.2-1
+- Uncommitted changes


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2019686
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Shell-api, Generic
Disabled plugins: Perl, SugarActivity, Ocaml, PHP, Java, R, fonts, Haskell, C/C++
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Ankur Sinha (FranciscoD) 2021-11-16 18:07:18 UTC
Looks very good, one or two things to tweak :)

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present: autorelease used, ignore.

- you should use %{version} in Source0 instead of "0.4.2"
- you don't need numpy as a BuildRequires: you've used %pyproject_buildrequires -r, which will install it.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 45 files have unknown license. Detailed output of
     licensecheck in /home/asinha/dump/fedora-reviews/2019686-python-
     pynrrd/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
^
Please see the note about using the %{version} macro.

[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
^
Included, checked using `rpm -ql --licensefiles -p ..`

[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
^
We're using autochangelog and autorelease, so this is fine.

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:

Ran manually:

$ rpmlint ./python3-pynrrd-0.4.2-1.fc36.noarch.rpm ./python-pynrrd-0.4.2-1.fc36.src.rpm ../srpm-unpacked/python-pynrrd.spec 
======================================================== rpmlint session starts ========================================================
rpmlint: 2.1.0
configuration:
    /usr/lib/python3.10/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/licenses.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 3

python-pynrrd.src: W: strange-permission python-pynrrd.spec 600
========================= 2 packages and 1 specfiles checked; 0 errors, 1 warnings, 0 badness; has taken 2.0 s =========================


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/mhe/pynrrd/archive/refs/tags/v0.4.2.tar.gz :
  CHECKSUM(SHA256) this package     : 0e0c60c9927adb31d97a7e3d00756dec987f115b2857dec0d6e4641490acfbd6
  CHECKSUM(SHA256) upstream package : 0e0c60c9927adb31d97a7e3d00756dec987f115b2857dec0d6e4641490acfbd6


Requires
--------
python3-pynrrd (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(numpy)



Provides
--------
python3-pynrrd:
    python-pynrrd
    python3-pynrrd
    python3.10-pynrrd
    python3.10dist(pynrrd)
    python3dist(pynrrd)



Diff spec file in url and in SRPM
---------------------------------
--- /home/asinha/dump/fedora-reviews/2019686-python-pynrrd/srpm/python-pynrrd.spec	2021-11-16 17:52:30.539187061 +0000
+++ /home/asinha/dump/fedora-reviews/2019686-python-pynrrd/srpm-unpacked/python-pynrrd.spec	2021-11-14 15:56:16.000000000 +0000
@@ -1,2 +1,11 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.2.5)
+%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
+    release_number = 1;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
+## END: Set by rpmautospec
+
 Name:           python-pynrrd
 Version:        0.4.2
@@ -67,4 +76,4 @@
 
 %changelog
-%autochangelog
-
+* Sun Nov 14 2021 Hafsat Ajia-EGbeyemi <hafsatajia> 0.4.2-1
+- Uncommitted changes


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2019686
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Python, Generic
Disabled plugins: Perl, PHP, C/C++, fonts, Ocaml, R, Java, SugarActivity, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 6 Hafsat 2021-11-18 12:18:39 UTC
Thank you so much FranciscoD for the review. I have implemented the changes.
Kindly find below the updated spec/srpm:
spec: https://pagure.io/python-pynrrd/raw/d8a13a6e66f33502d98e5621a08751a8be82f42b
SRPM: https://pagure.io/python-pynrrd/raw/d8a13a6e66f33502d98e5621a08751a8be82f42b/f/python-pynrrd-0.4.2-2.fc36.src.rpm

Comment 7 Ankur Sinha (FranciscoD) 2021-11-18 13:29:40 UTC
(In reply to Hafsat from comment #6)
> Thank you so much FranciscoD for the review. I have implemented the changes.
> Kindly find below the updated spec/srpm:
> spec:
> https://pagure.io/python-pynrrd/raw/d8a13a6e66f33502d98e5621a08751a8be82f42b

This isn't the link to the spec and fedora-review won't find it :(. Please comment with the correct link.

Comment 8 Hafsat 2021-11-19 00:34:43 UTC
Silly mistake by me. Thank you for the correction, FranciscoD.
Kindly find the correct link
Spec - https://pagure.io/python-pynrrd/raw/main/f/python-pynrrd.spec
SRPM -  https://pagure.io/python-pynrrd/raw/main/f/python-pynrrd-0.4.2-2.fc36.src.rpm

Comment 9 Ankur Sinha (FranciscoD) 2021-11-26 15:59:07 UTC
Looks very good, *almost* there :)

- BuildRequires: numpy -> BuildRequires: python3-numpy

This is because we want to be specific about that we need here.

- %py3_check_import nrrd -> %py3_check_import

I learned in one of my package reviews that there's no need to specify the module name here.. It will automatically check all the modules that `pyproject_save_files` macro finds. if we specify one, it'll *only* check for the one instead, so we shouldn't do that.

Here's the guideline:

https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_test_macros

Once these tweaks are made, this package will be ready for approval :)

Cheers,
Ankur

Comment 10 Ankur Sinha (FranciscoD) 2022-01-17 13:40:16 UTC
Hi @hafsatajia 


How's this one going? Anything we can do to help move it along?

Cheers,

Comment 11 Ankur Sinha (FranciscoD) 2022-01-31 10:21:50 UTC
Hi Hafsat,

How is this going?

Cheers,

Comment 12 Ankur Sinha (FranciscoD) 2022-02-08 14:47:07 UTC
Hafsat is still working on this, so we'll leave it open. Please let us know if we can help in any way, Hafsat :)

Comment 13 Package Review 2022-02-18 00:45:13 UTC
This is an automatic action taken by review-stats script.

The ticket submitter failed to clear the NEEDINFO flag in a month.
As per https://fedoraproject.org/wiki/Policy_for_stalled_package_reviews
we consider this ticket as DEADREVIEW and proceed to close it.


Note You need to log in before you can comment on or make changes to this bug.